                                                             (* 4.4.1998 *)
{

}

PROGRAM folium;
USES CRT,UNIGRA12;

 (* ----------------------- Unterprogramme ------------------------------- *)
  Procedure Ausgangszustand_definieren;
   BEGIN
   Plotter_einschalten;
   Graphik_einschalten('');
   Weltgrenzen_festlegen(einh);
   Viewport_festlegen;
   GeraetefensterPlotter_festlegen;
   Parameter2D;
   Viewport_zeichnen; 
   Koordinatenachsen_zeichnen;
   Gitter(0.1,1.0,5.0);  (* Strich,              klE,             grE     *)
                       (* grosse Strichlaenge,kleine Einheit, grosse Einh *)
  END;

  Procedure Beschriftung;
  CONST
  N = 10;
  VAR
  XUntergr,XObergr,YUntergr,YObergr         : STRING[Bz1];
  einhS: STRING[Bz1];
  Ttemp1,Ttemp2: STRING[Bz2];
  T: Ttyp;
  PText : Pt2DInt;
  BEGIN
  STR(WI2D[1].X:5:1,XUntergr); STR(WI2D[1].Y:5:1,YUntergr);
  STR(WI2D[2].X:5:1,XObergr);  STR(WI2D[2].Y:5:1,YObergr);
  STR(einh:5:1,einhS);
   
  
(* ----------------------------- TEXTE --------------------------------- *)

  T[1] := ' Folium ( Kepler, 1609 )';
  T[2] := ' R := cos(t) * ( 4*a * sin(t) * sin(t)-b) ';
  T[3] := ' X := R*COS(T), Y := R*SIN(T) ' ;
  T[4] := ' a := 4.0,  b := 4.0';
        Ttemp1 := ' Weltgrenzen: X von'+XUntergr+' bis'+XObergr+',';
        Ttemp2 := ' Y von'+YUntergr+' bis'+YObergr;
  T[5] := Ttemp1 + Ttemp2;
  T[6] := ' 1 Einheit entspricht'+einhS+' cm';
  Text_ausgeben(T,6);                                 (* .. Texte ausgeben *)
  END;



 Procedure TtoXY(T: EXTENDED; VAR X,Y: EXTENDED);
    VAR
    R,a,b: EXTENDED;
    BEGIN
    (* ================================================== *)
      a := 4.0;
      b := 4.0;
      R := cos(t)*( 4.0*a*sin(t)*sin(t)-b);
      X := R*COS(T);                            (* Umrechnung in           *)
      Y := R*SIN(T);                            (* Kartesische Koordinaten *)
    (* ================================================== *)
    END;

 Procedure Zeichne_Kurve;
   VAR
     I: INTEGER;
     X,Y,T,DeltaT,TMax,Tmin: EXTENDED;
     Punkt: Pt2D;
   BEGIN
     IF PLOT THEN WRITE(AUX,'PW');               (*  duenner Strich       *)
     TMin:=0.001;
     TMax:=4*PI;
     DeltaT:=0.01;
     T := TMin;
     TtoXY(T,X,Y);
     Punkt.X := X; Punkt.Y := Y;
     MoveToPt2D(Punkt);
     WHILE T < TMax DO
       BEGIN
         TtoXY(T,X,Y);;
         Punkt.X := X; Punkt.Y := Y;
         DrawLine2D(PLast,Punkt,Col);
         T:=T+DeltaT;
       END;
       IF PLOT THEN WRITE(AUX,'PW0.1');               (*  duenner Strich       *)
    END;

 (* ====================================================================  *)
 (*                         HAUPTPROGRAMM                                 *)

BEGIN
  Schnittstelle_waehlen(1);                (* 2 bedeutet auf Datei plotten *)
  Plot := FALSE;
  einh := 2.0;    (* 1 Einheit auf der X-Achse und Y-Achse entspricht 1 cm *)
                          (* erster Punkt links unten kann gewaehlt werden *)
  WI2D[1].X := -7.0;  WI2D[1].Y := -5.0;      (* linker unterer Punkt     *)
                                               (* des Weltfensters         *)
  Ausgangszustand_definieren;                 (* Graphikgrundeinstellung   *)
  Zeichne_Kurve;
  Beschriftung;
  WClosegraph;
END.
 
      